package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.platform.bean.Position;
import org.springframework.data.domain.Page;

import java.util.List;

/**
 * @Description : 岗位服务接口
 * @Reference :
 * @Author : yunhao
 * @Date : 2018-10-19 16:36
 * @Modify :
 **/
public interface IPositionService {

    /**
     * 修改数据
     *
     * @param position
     */
    void updatePosition(Position position);

    /**
     * 根据Key 删除数据
     *
     * @param id
     */
    void deletePositionById(String id);

    /**
     * 根据id批量删除岗位
     * @param ids id数组
     * @return
     */
    void deletePositionByIds(String[] ids);

    /**
     * 新增数据
     *
     * @param position
     * @return
     */
    Position insertPosition(Position position);

    /**
     * 查询所有数据
     *
     * @return
     */
    List listPosition();

    /**
     * 复杂查询
     * @param position
     * @param pager
     * @return
     */
    ListPager<Position> queryPosition(Position position, Pager pager);

    /**
     * 根据Key 数据
     *
     * @param id
     * @return
     */
    Position getPositionById(String id);

    /**
     * 根据岗位信息进行查找
     * @param position
     * @param pager
     * @return
     */
    ListPager findPositionByPager(Position position, Pager pager);


}
