package cn.estsh.i3plus.core.apiservice.daoimpl;

import cn.estsh.i3plus.core.apiservice.dao.IUserPermissionDao;
import cn.estsh.i3plus.pojo.platform.bean.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.persistence.EntityManager;
import java.util.List;

/**
 * @Description :
 * @Reference :
 * @Author : wei.peng
 * @Date : 2018-10-25 20:32
 * @Modify :
 **/
@Service
public class UserPermissionDaoImpl implements IUserPermissionDao {

    public static final Logger LOGGER = LoggerFactory.getLogger(UserPermissionDaoImpl.class);

    @Autowired
    private EntityManager entityManager;


    @Override
    public List<Department> findDepartmentByUser(SysUser user) {
        LOGGER.info(" 查询用户所有部门 user id:{}", user.getId());
        String hql = "select d from RefUserDepartment as rud " +
                        " left join Department as d on d.id = rud.departmentId " +
                        " where rud.userId =:userId";
        return entityManager.createQuery(hql).setParameter("userId",user.getId()).getResultList();
    }

    @Override
    public List<SysRole> findSysRoleByUser(SysUser user) {
        LOGGER.info(" 查询用户所有角色  user id:{}", user.getId());

        String hql = "select sr from RefUserRole as rur " +
                    " left join SysRole as sr on sr.id = rur.roleId " +
                    " where rur.userId =:userId";
        //hql = "select rur from RefUserRole as rur,SysRole as where rur.userId =:userId and sr.id = rur.roleId";
        return entityManager.createQuery(hql).setParameter("userId",user.getId()).getResultList();
    }

    @Override
    public List<SysMenu> findSysMenuByUser(SysUser user) {
        LOGGER.info(" 查询用户所有菜单  user id:{}", user.getId());
        String hql = "select sm from RefUserRole as rur " +
                " left join RefRoleMenu as rrm on rrm.roleId = rur.roleId" +
                " left join SysMenu as sm on sm.id = rrm.menuId" +
                " where rur.userId =:userId";
        return entityManager.createQuery(hql).setParameter("userId",user.getId()).getResultList();
    }

    @Override
    public List<Position> findPositionByUser(SysUser user) {
        LOGGER.info(" 查询用户所有岗位  user id:{}", user.getId());
        String hql = "select p from RefUserPosition as rup " +
                " left join Position as p on p.id = rup.positionId" +
                " where rup.userId =:userId";
        return entityManager.createQuery(hql).setParameter("userId",user.getId()).getResultList();
    }


}
