package cn.estsh.i3plus.core.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.core.api.iservice.busi.ISysMessageService;
import cn.estsh.i3plus.core.api.iservice.busi.ISysMessageService;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.enumutil.ImppEnumUtil;
import cn.estsh.i3plus.pojo.platform.bean.SysMessage;
import com.alibaba.fastjson.JSON;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.annotation.Rollback;

import javax.transaction.Transactional;
import java.util.List;

/**
 * @Description : 测试 消息服务接口
 * @Reference :
 * @Author : yunhao
 * @Date : 2018-10-31 15:30
 * @Modify :
 **/
public class TestMessageServiceImpl extends TestBase {

    @Autowired
    ISysMessageService sysMessageService;

    /**
     * 测试 查询所有消息
     */
    @Test
    @Transactional
    public void testListSysMessage() {
        List list = sysMessageService.listSysMessage();
        System.out.println(JSON.toJSONString(list));
    }

    /**
     * 测试 根据id查询消息
     */
    @Test
    @Transactional
    public void testGetSysMessageById() {
        SysMessage sysMessage = sysMessageService.getSysMessageById("1057110061127700480");
        System.out.println(JSON.toJSONString(sysMessage));
    }

    /**
     * 测试 添加消息
     */
    @Test
    @Transactional
    @Rollback(false)
    public void testInsertSysMessage() {
        SysMessage sysMessage = new SysMessage();
        sysMessage.setMessageTitle("test-系统通知");
        sysMessage.setRedSendName("system");
        sysMessage.setMessageSendId(-1L);
        sysMessage.setRedMessageRecipientName("admin");
        sysMessage.setMessageRecipientId(-1L);
        sysMessage.setMessageTypeId(ImppEnumUtil.USER_MESSAGE_TYPE.NOTICE.getValue());
        sysMessage.setMessageStatusId(ImppEnumUtil.USER_MESSAGE_STATUS.UNREAD.getValue());
        sysMessage.setCreateDatetime("2018-11-01 16:58:00");

        for (int i = 0; i < 50; i++) {
            sysMessage.setId(null);
            sysMessage.setMessageTitle("test-系统通知" + i);
            sysMessageService.insertSysMessage(sysMessage);
        }
        System.out.println(JSON.toJSONString(sysMessage));
    }

    /**
     * 测试 修改消息
     */
    @Test
    @Transactional
    public void testUpdateSysMessage(){
        SysMessage sysMessage = sysMessageService.getSysMessageById("1057110613261684736");
        sysMessage.setMessageTitle("测试修改");

        sysMessageService.updateSysMessage(sysMessage);
    }

    /**
     * 测试 根据id删除消息
     */
    @Test
    @Transactional
    public void testDeleteSysMessageById(){
        sysMessageService.deleteSysMessageById("1057111616417566720");
    }

    /**
     * 测试 复杂查询
     */
    @Test
    @Transactional
    public void testQuerySysMessageByPager(){
        SysMessage sysMessage = new SysMessage();

        Pager pager = new Pager();
        pager.setPageSize(10);
        pager.setCurrentPage(5);

        ListPager list = sysMessageService.querySysMessageByPager(sysMessage,pager);
        System.out.println(list);
    }
}
